//+------------------------------------------------------------------+
//|                                                VininE 10_pips.v1 |
//|                                            mailto: Vinin@mail.ru |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev aka Vinin"
#property link      "mailto: vinin@mail.ru"

extern string S1="  JMA";
extern double       FastLen=40;
extern double       SlowLen=80;
extern double       phase=-100;
extern int       barscount=1000;

extern string S2=" ";
extern double Lots_0= 1;
extern double Lots_1= 2;
extern double Lots_2= 3;
extern double Lots_3= 5;
extern double Lots_4= 9;
extern double Lots_5=15;
extern double Lots_6=23;
extern double Lots_7=40;
extern double Lots_8=67;



extern int  TakeProfit=50;
extern int  StopLoss=30;
extern int  Magic=777777;
extern bool bBar=true;
extern int CheckPos=1;

string _comment="VininE_Game_3";

int Order_Count[2];
double Lots[9];
int N;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {//0
   double MinLot=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLot=MarketInfo(Symbol(),MODE_MAXLOT);

   Lots[0]=iif(Lots_0>0,MathMax(MinLot,MathMin(MaxLot,Lots_0)),0);
   Lots[1]=iif(Lots_1>0,MathMax(MinLot,MathMin(MaxLot,Lots_1)),0);
   Lots[2]=iif(Lots_2>0,MathMax(MinLot,MathMin(MaxLot,Lots_2)),0);
   Lots[3]=iif(Lots_3>0,MathMax(MinLot,MathMin(MaxLot,Lots_3)),0);
   Lots[4]=iif(Lots_4>0,MathMax(MinLot,MathMin(MaxLot,Lots_4)),0);
   Lots[5]=iif(Lots_5>0,MathMax(MinLot,MathMin(MaxLot,Lots_5)),0);
   Lots[6]=iif(Lots_6>0,MathMax(MinLot,MathMin(MaxLot,Lots_6)),0);
   Lots[7]=iif(Lots_7>0,MathMax(MinLot,MathMin(MaxLot,Lots_7)),0);
   Lots[8]=iif(Lots_8>0,MathMax(MinLot,MathMin(MaxLot,Lots_8)),0);
   int i;
   N=0;
   for (i=0;i<8;i++) if (Lots[i]==0.0) {Lots[i]=Lots[i+1];Lots[i+1]=0;}
   for (i=0;i<9;i++) if (Lots[i]>0.0) N++;


   return(0);}//0

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
//   HistoryCalculate();
   return(0); 
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() { 
   if (bBar)  if (!NevBar()) return(0);

   int cmd=CheckOpen();
   if (cmd==-1) return(0);
   Order_Count_Calculate();
   if (Order_Count[cmd]>0) return(0);  //     
   int oldcmd=MathAbs(cmd-1);
   if (Order_Count[oldcmd]>0) Order_Close(oldcmd);  //   
   Order_Open(cmd);
   return(0);
} 

//===============================================================================
//    
//===============================================================================
bool NevBar(){
   bool RetVal=false;
   static int TimeOld=0;
   if (TimeOld!=Time[0]) {
      TimeOld=Time[0];
      RetVal=true;
   }
   return(RetVal);
}


//===============================================================================
//   
//===============================================================================
int CheckOpen(){
   double Fasttmp0=iCustom(Symbol(),Period(),"JMA",FastLen,phase,barscount,0,CheckPos);
   double Fasttmp1=iCustom(Symbol(),Period(),"JMA",FastLen,phase,barscount,0,CheckPos+1);
   double Slowtmp0=iCustom(Symbol(),Period(),"JMA",SlowLen,phase,barscount,0,CheckPos);
   double Slowtmp1=iCustom(Symbol(),Period(),"JMA",SlowLen,phase,barscount,0,CheckPos+1);
   if (Fasttmp0>Slowtmp0 && Fasttmp1<=Slowtmp1) return(0);
   if (Fasttmp0<Slowtmp0 && Fasttmp1>=Slowtmp1) return(1);
   return(-1);
}

//===============================================================================
//          
//===============================================================================
void Order_Count_Calculate(){
   int i;
   for (i = 0; i < 6; i++) {Order_Count[i] = 0;}
   for (i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == Magic) {
               Order_Count[OrderType()]++;
            }
         }
      }
   }
}


//======================================================================================================
//   
//=====================================================================================================
bool Order_Close(int OP){
   Order_Count_Calculate();
   if (Order_Count[OP]>0) {
      for(int i = OrdersTotal() - 1;  i >= 0;  i--) {
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == Symbol()) {
               if (OrderMagicNumber() == Magic) {
                  if (OrderType()==OP) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 3, iif(OrderType()==OP_BUY,Red,Blue));
                  }
               }
            }
         }
      }
   }
   return(false);
}
//======================================================================================================
//   
//=====================================================================================================
int Order_Open(int OP){
   int cmd=iif(OP==OP_BUY,1,-1);
   Order_Count_Calculate();
   if (Order_Count[OP]>0) return(0);
   double lots=GetLots();
   double price= iif(cmd==1,Ask,Bid);
   double _sl=iif(StopLoss==0,0,price-cmd*StopLoss*Point);
   double _tp=iif(TakeProfit==0,0,price+cmd*TakeProfit*Point);
   int ticket=OrderSend(Symbol(), OP, lots,price, 3,_sl,_tp,_comment,Magic, 0, iif(OP==OP_BUY,Blue,Red)); 
   return(ticket); 
}

//===============================================================================
//         
//===============================================================================
double GetLots() {
   double lot=Lots[0], LotP;
   int i,j;
   for (i=OrdersHistoryTotal()-1;i>=0;i--) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
            if (OrderProfit()<0) {
               LotP=OrderLots();
               for (j=0;j<N;j++) if (LotP==Lots[j] && j<N-1) lot=Lots[j+1];
            }
            break;
         }
      }
   }
   
   
   return(lot); 
}


//======================================================================================================
//    
//=====================================================================================================
int Sign(double A) {if(A>0) return(1); if(A<0) return(-1); return(0); }

//======================================================================================================
//   
//=====================================================================================================
double iif(bool A, double B, double C) {if(A) return(B); return(C); }

//======================================================================================================
//    
//=====================================================================================================
void _Sleep(int N){
   if (!(IsTesting() || IsOptimization())) {
      Sleep(N); 
   }
   RefreshRates();
}


